% GETDEGRS Auxiliary function to compute degrees of opened vacancies and 
% all positions.
% INPUTS: 
% adjacency matrices of years 1 (A1) and 2 (A2).
% OUPUTS: 
% ndeg; the degree histrogram of all positions occupied by someone 
% (empty ones are excluded),
% ndegold; the degree histrogram of opened vacancies, 
% (that were occupied by someone or were empty),
% nnew, is the number of new board members (empty seats are allocated to new)
function [ndeg,ndegold,nnew]=getdegrs(A1,A2)

templmat1=(A1==1 & A2==0);%Indicator of people who have left
templmat2=(A1==0 & A2==1);%indicator of new comers

firms=find(any(templmat1|templmat2,2));%firms for which someone has arrived or someone has left
nnew=0;
ndeg=0;
ndegold=0;
for j=1:size(A1,2) %Loop over individuals
odeg=full(sum(templmat1(:,j)));%how many boards there are from which the individual has left
deg=full(sum(A1(:,j))); %how many board positions the individual had in total 
if odeg>0
if length(ndegold)>=deg
ndegold(deg)=ndegold(deg)+odeg;%there are odeg number of old positions more in which the degree was deg 
else
ndegold=[ndegold zeros(1,deg-length(ndegold))];
ndegold(deg)=odeg;
end
end

if deg>0
if length(ndeg)>=deg
ndeg(deg)=ndeg(deg)+deg; %note that the question is on the distribution of degrees of positions
else
ndeg=[ndeg zeros(1,deg-length(ndeg))];
ndeg(deg)=deg;
end
end

if sum(A1(:,j))==0 %individual j is a new comer
%count the number of positions that the individual has in the new list, add this to the number of positions with a new comer
nnew=nnew+sum(A2(:,j));
end
end%end of for (loop over individuals)

for j=1:length(firms);
%if more people have left than arrived, then some positions are left empty, put these into degree one group
%however, at the same time there can be some new people as well, and these are treated in the previous loop
dif=sum(A1(firms(j),:))-sum(A2(firms(j),:)); %decrease in the number of positions 
if dif<0 %number of positions has increased, i.e., empty seats have been filled, add these empty seats to group of degree one vacancies
ndegold(1)=ndegold(1)-dif;
elseif dif>=0 %in this case some vacancies have been left empty, treat these seats as if allocated to new people
nnew=nnew+dif;
end

end%enf of for over firms;
