% UNIONIDVS creates two new adjacency matrices from A1 and A2 corresponding to 
% the union of two lists of individuals idvs1 and idvs2.
% INPUTS:
% lists of individuals given as vectors of indices idvs1 and idvs2,
% adjacency matrices of two time periods A1 and A2,
% OUTPUTS:
% assume that the union of idvs1 and idvs2 has n individuals
% adjacency matrices out1 and out2 are of the size m x n where m is 
% the number of firms, if individual j is not in idvs1 then the corresponding 
% column in out1 contains zeros (and the same way for out2)
function [out1,out2,indoldidvs,indnewidvs]=unionidvs(idvs1,idvs2,A1,A2)

out1=A1;out2=A2;
m=size(A1,1);
if size(idvs1,2)>=size(idvs1,1)
idvs1=idvs1';
end
if size(idvs2,2)>=size(idvs2,1)
idvs2=idvs2';
end

[idvs1,sortl1]=sort(idvs1);
[idvs2,sortl2]=sort(idvs2);
out1=out1(:,sortl1);
out2=out2(:,sortl2);

[unionidvs]=union(idvs1,idvs2);

[tempidvs,indoldidvs]=setdiff(idvs1,idvs2); %people who are in idvs1 but not in idvs2
[tempidvs]=setdiff(idvs2,idvs1);%people who are in idvs2 but not in idvs1
[tempidvs,Itemp,indnewidvs]=intersect(tempidvs,unionidvs);%finding the indices of new individuals

cntr1=0;
cntr2=0;
n=length(unionidvs);
n2=length(idvs2);
n1=length(idvs1);

%unionidvs
for i=1:n
if i-cntr2<=n2
if ~strcmp(idvs2{i-cntr2},unionidvs{i})
if i>1 && i-cntr2<n2
out2=[out2(:,1:i-1) zeros(m,1) out2(:,i:end)];
elseif i==1
out2=[zeros(m,1) out2(:,1:end)];
elseif i-cntr2==n2
out2=[out2(:,1:end-1) zeros(m,1) out2(:,end)];
end%end of if
cntr2=cntr2+1;
end
else
out2=[out2(:,1:end) zeros(m,1)];
end

if i-cntr1<=n1

if ~strcmp(idvs1{i-cntr1},unionidvs{i})

if i>1 && i-cntr1<n1
out1=[out1(:,1:i-1) zeros(m,1) out1(:,i:end)];
elseif i==1
out1=[zeros(m,1) out1(:,1:end)];
elseif i-cntr1==n1
out1=[out1(:,1:end-1) zeros(m,1) out1(:,end)];
end%end of if 
cntr1=cntr1+1;
end
else
out1=[out1(:,1:end) zeros(m,1)];
end

end
