%Example on how to get descriptive statistics from edgelists of a
% given time period.

%First year
fyr=2012;
%Last year
lyr=2015;

%Selection of firms that are either in the main component at least once, or indirectly connected to such a firm
firmlist=firmselection(fyr,lyr,[],3);
%Getting the yearly statistics of the sample.
descriptives=getdescriptivestats(fyr,lyr,firmlist);
%Aggregation of the yearly distributions.
aggdescriptives=aggregatedist(descriptives);

%Degree distribution:
%histogram of degrees new individuals conditional on that they are found in some neighborhood
figure(1)
clf;
plot(aggdescriptives{4},'r');

%Distance distribution:
%histogram of distances of new individuals, note the last value is the number of persons not found in any neighborhood
figure(2) 
clf; 
plot(aggdescriptives{2}(1:min(10,length(aggdescriptives{2}))-1),'r');
