% ADD2DIST Adding distributions or histograms.
% If flag=0, data is 'raw', otherwise it is a distribution.
% In the case of flag=0, rawdata is an arbitrary vector of integers. 
% Otherwise, rawdata contains numbers of elements of different bins; r
% awdata(i) is the number of observations in the bin i.
% The input variable olddist is assumed to contains numbers of elements of
% different bins.
% The output is a distribution where observations or the distribution 
% corresponding to rawdata is added to the olddate corresponding to olddist.
function totaldist=add2dist(rawdata,olddist,flag,minval)

if nargin<4 || isempty(minval)
minval=1;
end

if flag==0
newhist=histc(rawdata,[minval:1:max(minval,max(rawdata))]);
else
newhist=rawdata;
end

m=length(newhist);
n=length(olddist);

if size(newhist,1)==m
newhist=newhist';
end
if size(olddist,1)==n
olddist=olddist';
end


if isempty(newhist)
totaldist=olddist;

else

if ~isempty(olddist)
if n>m
totaldist(1:m)=newhist+olddist(1:m);
totaldist(m+1:n)=olddist(m+1:n);
elseif n==m
totaldist=newhist+olddist;
else
totaldist(1:n)=newhist(1:n)+olddist;
totaldist(n+1:m)=newhist(n+1:m);
end

else
totaldist=newhist;
end

end
end
