% AVERAGEHIST Auxiliary function to aggregate degree and distance distributions
% over different simulation runs.
% INPUTS:
% degdiss cell array containg the degree distribution of all people in each run,
% distds distance distributions of newly recruited people in each run,
% degnewds degrees distributions of newly recruited people in each run,
% degoldds degrees distributions of people who lost a position in each run
% OUTPUTS:
% histograms obtained by averaging over the simulation runs
% Requirements: add2dist
function [degdis,distd,degnewd,degoldd]=averagehist(degdiss,distds,degnewds,degoldds)

[n,m]=size(distds);
degdis=[];
distd=[];
degnewd=[];
degoldd=[];

for j=1:m
degdis=add2dist(degdiss{j},degdis,1);
distd=add2dist(distds{j},distd,1);
degnewd=add2dist(degnewds{j},degnewd,1);
degoldd=add2dist(degoldds{j},degoldd,1);
end

degdis=degdis./m;
distd=distd./m;
degnewd=degnewd./m;
degoldd=degoldd./m;
