% FASTSETDIFF Set difference of two vectors vec1 and vec2, i.e. 
% "vec1 setminus vec2". This function is considerably faster than setdiff and
% relies on the use of lookup function.
% INPUTS: should be sorted row or column vectors.
% OUPUTS: output contains the vector of elements in "vec1 setminus vec2", 
% index contains the indices of the elements corresponding to vec1.
function [output,index1,index2]=fastintersect(vec1,vec2)

index1=lookup(vec1,vec2,'m');%this takes intersection
index1(index1==0)=[]; %note indx==0 if fimrs1 has an index less than the least index
output=vec1(index1);

if nargout==3
index2=lookup(vec2,vec1,'m');%this takes intersection
index2(index2==0)=[]; %note indx==0 if fimrs1 has an index less than the least index
end
