% Extract the giant component of a graph;
% The giant component is the largest connected component.
% 
% INPUTS: adjacency matrix, nxn
% OUTPUTS: giant component matrix and node indices of the giant component
%
% Other routines used: fastsetdiff, findConnCompAlt.m and findConnCompIAlt.m
% Note: originally from networks toolbox, this version uses slightly 
% different way to find connected components

function [GC,gc_nodes]=giantComponentAlt(adj)

comp=findConnCompAlt(adj);

L=[];
for k=1:length(comp); L=[L, length(comp{k})]; end  % computing component sizes
[maxL,ind_max]=max(L);

gc_nodes=comp{ind_max};
GC=adj(gc_nodes,gc_nodes);
