% PARSEFITOPTIONS Function for setting the options of fitsearchmodel. 
% Note that the default values are set here.
% INPUT: 
% fitoptions structure, for the available fields see the help of fitsearchmodel.
% OUTPUTS: options that are used in fitsearchmodel
function [initalpha,initbeta,initgamma,initdinf,nsims,bsflag,nbs,cmax,caseflag,alphaflag,saveflag,filename,rmflag,plotflag,initflag,tolx]=parsefitoptions(fitoptions)

if isempty(fitoptions) || ~isfield(fitoptions,'initalpha') || isempty(fitoptions.initalpha)
initalpha=0.03;
else
initalpha=fitoptions.initalpha;
end

if isempty(fitoptions) || ~isfield(fitoptions,'initbeta') || isempty(fitoptions.initbeta)
initbeta=1;
else
initbeta=fitoptions.initbeta;
end

if isempty(fitoptions) || ~isfield(fitoptions,'initgamma') || isempty(fitoptions.initgamma)
initgamma=1;
else
initgamma=fitoptions.initgamma;
end

if isempty(fitoptions) || ~isfield(fitoptions,'initdinf') || isempty(fitoptions.initdinf)
initdinf=15;
else
initdinf=fitoptions.initdinf;
end

if isempty(fitoptions) || ~isfield(fitoptions,'nsims') || isempty(fitoptions.nsims)
nsims=1;
else
nsims=fitoptions.nsims;
end

if isempty(fitoptions) || ~isfield(fitoptions,'bsflag')
bsflag=false;
nbs=[];
nbsopt=[];
else
bsflag=fitoptions.bsflag;
nbs=[];
nbsopt=[];
end

if bsflag==true

if ~isfield(fitoptions.nbs) || (isempty(fitoptions.nbs) | fitoptions.nbs<=0) 
nbs=30;
else
nbs=fitoptions.nbs;
end
end

if isempty(fitoptions) || ~isfield(fitoptions,'cmax') || isempty(fitoptions.cmax) || fitoptions.cmax<=0
cmax=[];
else
cmax=fitoptions.cmax;
end

if isempty(fitoptions) || ~isfield(fitoptions,'caseflag') || isempty(fitoptions.caseflag)
caseflag=3;
else
caseflag=fitoptions.caseflag;
end

if isempty(fitoptions) ||  ~isfield(fitoptions,'alphaflag') || isempty(fitoptions.alphaflag)
alphaflag=false;
else
alphaflag=fitoptions.alphaflag;
end

if isempty(fitoptions) || ~isfield(fitoptions,'saveflag') || isempty(fitoptions.saveflag)
saveflag=false;
filename=[];
else
saveflag=fitoptions.saveflag;
if isfield(fitoptions,'filename')
outfilesname=fitoptions.filename;
else
filename='simulationoutputs';
end
end

if isempty(fitoptions) || ~isfield(fitoptions,'rmflag') || isempty(fitoptions.rmflag)
rmflag=false;
else
rmflag=fitoptions.rmflag;
end

if isempty(fitoptions) || ~isfield(fitoptions,'rmflag') || isempty(fitoptions.rmflag)
rmflag=false;
else
rmflag=fitoptions.rmflag;
end

if isempty(fitoptions) || ~isfield(fitoptions,'plotflag') || isempty(fitoptions.plotflag)
plotflag=false;
else
plotflag=fitoptions.plotflag;
end

if isempty(fitoptions) || ~isfield(fitoptions,'tolx') || isempty(fitoptions.tolx) || fitoptions.tolx<=0
tolx=0.05;
else
tolx=fitoptions.tolx;
end

if isempty(fitoptions) || ~isfield(fitoptions,'initflag') || isempty(fitoptions.initflag) || fitoptions.initflag==true
initflag=true;
else
initflag=false;
end
