% SIMOBJ computes the different terms of the objective function.
% INPUTS: the usual parameters and the state of the random number generator
% OUTPUTS:
% termbetap the square difference of degree dsitributions,
% termgammap the square difference of the first part of the distance 
% distribution (outsiders excluded),
% termdinf the square difference of proportion of people recruited 
% outside of any neighborhoods,
% dis1 the distance distribution corresponding to the parameter values,
% dis2 the degree distribution correspondiong to the parameter values,
% REQUIREMENTS:  add2dist, simuloop (and all the functions required therein)
function [termbetap,termgammap,termdinf,dis1,dis2]=simobj(betap,gammap,dinf,pn,pout,K,didisnew,dedisnew,Ainit,nsim,ntime,cmax,rstate)

%MAIN 'LOOP' (that is parallelized)
A=Ainit;
[distd,degnewd]=pararrayfun(nproc,@(seed) simuloop(Ainit,pn,pout,betap,gammap,dinf,K,ntime,cmax,rstate,seed),[0:1:nsim-1],"Uniformoutput",false,"VerboseLevel",0);

totaldis=[];
totaldeg=[];
for j=1:nsim %run the simulation nsim times and take the average
totaldis=add2dist(distd{j},totaldis,1);
totaldeg=add2dist(degnewd{j},totaldeg,1);
end

termdinf=(totaldis(end)./sum(totaldis(2:end))-didisnew(end))^2;

dis1r=totaldis(2:end-1)./sum(totaldis(2:end));
didisr=didisnew(1:end-1)./(sum(didisnew(1:end)));
nmin1=min(length(dis1r),length(didisr));
termgammap=norm(dis1r(1:nmin1)-didisr(1:nmin1))^2;
outval=norm(dis1r(1:nmin1)-didisr(1:nmin1))^2;
if length(dis1r)>length(didisnew)
termgammap=outval+norm(dis1r(nmin1+1:end))^2;
elseif length(dis1r)<length(didisr)
termgammap=termgammap+norm(didisr(nmin1+1:end))^2;
end

dis1=totaldis(2:end)./sum(totaldis(2:end));

dis2=totaldeg(2:end)./sum(totaldeg(2:end));
nmin2=min(length(dis2),length(dedisnew));

termbetap=norm(dis2(1:nmin2)-dedisnew(1:nmin2))^2;

if length(dis2)>length(dedisnew)
termbetap=termbetap+norm(dis2(nmin2+1:end))^2;
elseif length(dis2)<length(dedisnew)
termbetap=termbetap+norm(dedisnew(nmin2+1:end))^2;
end
