% SIMULOOP Running a simulation of the exponential search model for ntime periods.
% This function is used within simobj.
% INPUTS:
% Ainit initial adjacency matrix of the two-mode network,
% model parameters pn, p0, alpha, betap, gammap, dinf, K,
% ntime number of time periods,
% cmax maximum number of neighborhoods went through in the distance computation.
% rstate is the state of the random number generator rand and snum is number added
% to the state.
% OUTPUTS: 
% distd is is the distance distribution of new appointments
% dednewd is the degree distribution
% REQUIREMENTS: add2dist, fastsetdiff, findallneighbors, newrandpeople, 
% openvacancies, updateadj
function [distd,degnewd]=simuloop(Ainit,pn,pout,betap,gammap,dinf,K,ntime,cmax,rstate,snum)

if nargin<9
cmax=[];
end

if nargin>=10 && ~isempty(seed)
rstate=rstate+snum; 
%seeding the random number generator, state of the random number generator
else
rstate=[];
end

distd=[];
degnewd=[];
cntr=1;
A=Ainit;

%The main loop
while cntr<=ntime
[A,distnew,degnew,degold,rstate]=updateadj(A,betap,gammap,pout,pn,K,dinf,cmax,rstate);%updating the network and getting data on distances and degrees
distd=add2dist(distnew,distd,1);%distance data
degnewd=add2dist(degnew,degnewd,1); 
cntr=cntr+1;
end%end of main loop
